require 'targetmy/config/site'
require 'ostruct'

module Targetmy
  class Config
    attr_reader :items

    SUPPORTED_ADV_TYPES = [:site]

    def initialize(config)
      @items = []

      parse config
    end

    def parse(config)
      config = config.is_a?(Hash) ? [config] : config
      config.each do |cnf|
        if SUPPORTED_ADV_TYPES.include? cnf[:type].to_sym
          type = cnf[:type].to_s.capitalize
          klass = Object.const_get("Targetmy::Config::#{type}")
          @items << klass.new(cnf)
        else
          raise Targetmy::UnsupportedKey.new(cnf[:type].to_sym)
        end
      end
    end
  end
end